import os
from datetime import datetime


class ProcessParser:
    command_output = []
    user_processes = []

    def load(self):
        list_jobs = os.popen("ps xao user,pid,sid,uid,lstart,command")
        lines = list_jobs.read().split("\n")
        self.command_output = [line.split(maxsplit=9) for line in lines]
        self.command_output.pop(0)
        self.command_output.pop()
        list_jobs.close()
        return self

    def load_test_file(self):
        with open("../test_files/dc_psout", "r") as job_file:
            job = job_file.readline()
            while job:
                job = job_file.readline()
                self.command_output.append(job.split(maxsplit=9))
        return self

    def isolate_important_processes(self):
        processes = []
        for proc in self.command_output:
            if proc:
                if int(proc[3]) >= 1000:
                    processes.append(proc)
        self.user_processes = processes

    def parse(self, jobs):
        self.isolate_important_processes()
        processes = {}
        for proc in self.user_processes:
            stime = datetime.strptime(" ".join(proc[5:9]), "%b %d %H:%M:%S %Y")
            stime_timestamp = int(stime.timestamp())
            proc_dict = {
                "user": proc[0],
                "pid": proc[1],
                "sid": proc[2],
                "uid": proc[3],
                "stime": stime_timestamp,
                "time": 0,
                "command": proc[9]
            }
            processes["%s_%s_%s" % (proc[0], proc[1], stime_timestamp)] = proc_dict
        for line in self.user_processes:
            stime = datetime.strptime(" ".join(line[5:9]), "%b %d %H:%M:%S %Y")
            stime_timestamp = int(stime.timestamp())
            for job in jobs:
                if job[1] == line[2]:
                    proc_name = "%s_%s_%s" % (line[0], line[1], stime_timestamp)
                    processes[proc_name]["job"] = job
        return processes
